%define		pname suphp-iworx
%define		rname suphp
%define		pversion 0.7.1
%define 	bversion 107
%define		rpmrelease iworx

%define		iworxuser iworx
%define		iworxgroup iworx
%define		iworxwebuser  iworx-web
%define		iworxwebgroup iworx-web
%define		iworxdir /home/interworx
%define		iworxbindir %{iworxdir}/bin
%define		iworxsbindir %{iworxdir}/sbin
%define		iworxsysconfdir %{iworxdir}/etc
%define		iworxlibdir %{iworxdir}/lib
%define		iworxincdir %{iworxdir}/include

%define 	debug_package %{nil}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#

%define 	build_rht_90   0
%define		build_cos_3x   0
%define		build_fdr_10   0
%define		build_fdr_20   0
%define		build_fdr_30   0
%define		build_fdr_40   0
%define		build_fdr_80   0
%define		build_fdr_90   0
%define		build_whb_3x   0
%define		build_rhe_2x   0
%define		build_rhe_3x   0
%define		build_rhe_4x   0
%define		build_rhe_5x   0
%define		build_rhe_6x   0

%define		build_unk      1

# Command Line Overrides
%{?_with_rht90:   	%{expand: %%define build_rht_90   1}}
%{?_with_cos3x: 	%{expand: %%define build_cos_3x   1}}
%{?_with_fdr10: 	%{expand: %%define build_fdr_10   1}}
%{?_with_fdr20: 	%{expand: %%define build_fdr_20   1}}
%{?_with_fdr30: 	%{expand: %%define build_fdr_30   1}}
%{?_with_fdr40: 	%{expand: %%define build_fdr_40   1}}
%{?_with_fdr80: 	%{expand: %%define build_fdr_80   1}}
%{?_with_fdr90: 	%{expand: %%define build_fdr_90   1}}
%{?_with_whb3x: 	%{expand: %%define build_whb_3x   1}}
%{?_with_rhe2x: 	%{expand: %%define build_rhe_2x   1}}
%{?_with_rhe3x: 	%{expand: %%define build_rhe_3x   1}}
%{?_with_rhe4x: 	%{expand: %%define build_rhe_4x   1}}
%{?_with_rhe5x: 	%{expand: %%define build_rhe_5x   1}}
%{?_with_rhe6x: 	%{expand: %%define build_rhe_6x   1}}

%{?_with_unk: 		%{expand: %%define build_unk      1}}

# Distro Statements
%if %{build_rht_90}
%define		oscode rht90
%define 	ostype RedHat 9
BuildRequires:	httpd-devel
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_cos_3x}
%define		oscode cos3x
%define 	ostype CentOS 3.x
BuildRequires:	apr
BuildRequires:	apr-util
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_10}
%define		oscode fdr10
%define 	ostype Fedora Core 1
BuildRequires:	httpd-devel
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_20}
%define		oscode fdr20
%define 	ostype Fedora Core 2
BuildRequires:	httpd-devel
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_30}
%define		oscode fdr30
%define 	ostype Fedora Core 3
BuildRequires:	httpd-devel
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_40}
%define		oscode fdr40
%define 	ostype Fedora Core 4
BuildRequires:	apr
BuildRequires:	apr-util
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_80}
%define		oscode fdr80
%define 	ostype Fedora 8
BuildRequires:	httpd-devel
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_fdr_90}
%define		oscode fdr90
%define 	ostype Fedora Core 9
BuildRequires:	apr
BuildRequires:	apr-util
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_whb_3x}
%define		oscode whb3x
%define 	ostype White Box 3.x
BuildRequires:	apr
BuildRequires:	apr-util
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_2x}
%define		oscode rhe2x
%define 	ostype RedHat Enterprise 2.x
BuildRequires:	apr
BuildRequires:	apr-util
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_3x}
%define		oscode rhe3x
%define 	ostype RedHat Enterprise 3.x
BuildRequires:	apr
BuildRequires:	apr-util
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_4x}
%define		oscode rhe4x
%define 	ostype RedHat Enterprise 4.x
BuildRequires:	apr
BuildRequires:	apr-util
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_5x}
%define		oscode rhe5x
%define 	ostype RedHat Enterprise 5.x
BuildRequires:	apr
BuildRequires:	apr-util
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%if %{build_rhe_6x}
%define		oscode rhe6x
%define 	ostype RedHat Enterprise 6.x
BuildRequires:	apr
BuildRequires:	apr-util
Requires: 	httpd
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%define		build_unk 0
%endif

%define	release %{bversion}.%{oscode}.%{rpmrelease}

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		oscode unk
%define 	ostype Unknown Distribution
%define		release %{bversion}.%{rpmrelease}
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary:	suPHP -  suexec for PHP
Name:		%{pname}
Version:	%{pversion}
Release: 	%{release}
License:	GPL

Group:		System Environment/Daemons
Source0:	%{rname}-%{version}.tar.gz
URL:		http://www.suphp.org

Distribution:	InterWorx-HAL
Vendor:         INTERWORX L.L.C
Packager:	    Paul Oehler <poehler@interworx.com>

BuildRequires: httpd-iworx

BuildRoot:	%{_tmppath}/%{rname}-%{version}-root

Source1:	suphp-iworx-suphp.conf

%description
suPHP is a tool for executing PHP scripts with the permissions 
of their owners. It consists of an Apache module (mod_suphp) 
and a setuid root binary (suphp) that is called by the Apache 
module to change the uid of the process executing the PHP 
interpreter.

%prep

[ -n %{buildroot} ] && rm -rf %{buildroot}

[ -d %{_builddir}/%{name}-%{pversion} ] && rm -rf %{_builddir}/%{name}-%{pversion}

%setup -q -n %{rname}-%{pversion}

# Try detecting newest gcc (some distributions have got more then one compiler)
# and write it on a temp file 

[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{name}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{name}-%{pversion}-gcc
fi

# Display compilation flags and OS with colors ;)

[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags

# We have gcc written in a temp file
export CC="`cat %{_tmppath}/%{name}-%{pversion}-gcc` %{ccflags}"

# Delete gcc temp file
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

%build

[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

mkdir -p %{buildroot}

# Delete gcc temp file
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

if [ -f /home/interworx/bin/httpd/apr-config ]; then
   APR_INCLUDE="`/home/interworx/bin/httpd/apr-config --includedir`"
   APR_CONFIG="apr-config"
fi
if [ -f /home/interworx/bin/httpd/apr-1-config ]; then
   APR_INCLUDE="`/home/interworx/bin/httpd/apr-1-config --includedir`"
   APR_CONFIG="apr-1-config"
fi

export CFLAGS="$RPM_OPT_FLAGS -fomit-frame-pointer -fPIC -I$APR_INCLUDE"
export CPPFLAGS="$CFLAGS"

./configure                               \
	--prefix=%{iworxdir}     \
	--with-apxs=%{iworxbindir}/httpd/apxs     \
	--bindir=%{_bindir}               \
	--with-apr=%{iworxbindir}/httpd/$APR_CONFIG		  \
	--mandir=%{_mandir}               \
	--localstatedir=%{_localstatedir} \
	--libdir=%{iworxlibdir}               \
	--datadir=%{_datadir}             \
	--includedir=%{iworxincdir}       \
	--sysconfdir=%{iworxsysconfdir}       \
        --with-setid-mode=owner        \
	--with-min-uid=105                \
	--with-min-gid=105                \
	--with-apache-user=%{iworxuser}          \
	--with-logfile=%{iworxdir}/var/log/suphp.log

%{__make} %{?_smp_mflags}

%install

## make the "install" dir
mkdir -p %{buildroot}%{iworxsysconfdir}
mkdir -p %{buildroot}%{iworxbindir}/httpd/modules
mkdir -p %{buildroot}%{iworxsbindir}

install -m0755 src/apache2/.libs/mod_suphp.so \
	%{buildroot}%{iworxbindir}/httpd/modules
install -m4755 src/suphp \
	%{buildroot}%{iworxsbindir}

install -m0644 %{SOURCE1} \
	%{buildroot}%{iworxsysconfdir}/suphp.conf

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d %{_builddir}/%{name}-%{pversion} ] && rm -rf %{_builddir}/%{name}-%{pversion}

%pre
# make the iworx-web group (if needed)
/bin/grep "^%{iworxwebgroup}:" /etc/group >/dev/null || groupadd -r %{iworxwebgroup}

# make the iworx-web user (if needed)
/bin/grep "^%{iworxwebuser}:" /etc/passwd >/dev/null || /usr/sbin/useradd \
	-g %{iworxwebgroup} -d / \
	-s /sbin/nologin -c %{iworxwebuser} -r %{iworxwebuser}

%postun

[ -d %{_localstatedir}/%{name} ] && 
	rm -rf %{_localstatedir}/%{name} || :

%post
# make a php-cgi symlink if it doesn't already exist - suphp wants to use cgi mode

%preun
if [ "$1" == "0" ]; then
   echo
   echo "WARNING: suphp-iworx package removal request denied.  This package is required by Interworx."
   echo
   exit 1
fi


%files
%defattr(-,root,root)

%attr(0755,root,root) %dir %{iworxsbindir}
%attr(0755,root,root) %{iworxbindir}/httpd/modules/mod_suphp.so
%attr(0600,root,root) %{iworxsysconfdir}/suphp.conf
%attr(4750,root,iworx-web) %{iworxsbindir}/suphp

%changelog
* Sun Oct 03 2010 Paul Oehler <poehler@interworx.com>
- Added uninstall blocker preun script
* Wed Aug 11 2010 Paul Oehler <poehler@interworx.com>
- Cleaned up spec
* Thu May 06 2010 Paul Oehler <poehler@interworx.com>
- Updated for RHEL 6.x
* Thu Jun 23 2009 Paul Oehler <poehler@interworx.com>
- Initial packaging as part of InterWorx-HAL OS
